<center><a href="ex8.c">Actual source code: ex8.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:08+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests automatic allocation of matrix storage space.\n\n"</font>;

<a name="line4"> 4: </a> #include <A href="../../../../include/petscmat.h.html">petscmat.h</A>

<a name="line8">  8: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **args)</font></strong>
<a name="line9">  9: </a>{
<a name="line10"> 10: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            C;
<a name="line11"> 11: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j,m = 3,n = 3,Ii,J;
<a name="line13"> 13: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    v;
<a name="line14"> 14: </a>  <A href="../../../../docs/manualpages/Mat/MatInfo.html#MatInfo">MatInfo</A>        info;

<a name="line16"> 16: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;args,(char *)0,help);
<a name="line17"> 17: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-m"</font>,&amp;m,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line18"> 18: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-n"</font>,&amp;n,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line20"> 20: </a>  <font color="#B22222">/* create the matrix for the five point stencil, YET AGAIN */</font>
<a name="line21"> 21: </a>  <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,&amp;C);
<a name="line22"> 22: </a>  <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(C,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,m*n,m*n);
<a name="line23"> 23: </a>  <A href="../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>(C);
<a name="line24"> 24: </a>  <font color="#4169E1">for</font> (i=0; i&lt;m; i++) {
<a name="line25"> 25: </a>    <font color="#4169E1">for</font> (j=0; j&lt;n; j++) {
<a name="line26"> 26: </a>      v = -1.0;  Ii = j + n*i;
<a name="line27"> 27: </a>      <font color="#4169E1">if</font> (i&gt;0)   {J=Ii-n; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line28"> 28: </a>      <font color="#4169E1">if</font> (i&lt;m-1) {J=Ii+n; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line29"> 29: </a>      <font color="#4169E1">if</font> (j&gt;0)   {J=Ii-1; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line30"> 30: </a>      <font color="#4169E1">if</font> (j&lt;n-1) {J=Ii+1; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line31"> 31: </a>      v = 4.0; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;Ii,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line32"> 32: </a>    }
<a name="line33"> 33: </a>  }
<a name="line34"> 34: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(C,MAT_FINAL_ASSEMBLY);
<a name="line35"> 35: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(C,MAT_FINAL_ASSEMBLY);
<a name="line36"> 36: </a>  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(C,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);

<a name="line38"> 38: </a>  <A href="../../../../docs/manualpages/Mat/MatGetInfo.html#MatGetInfo">MatGetInfo</A>(C,MAT_LOCAL,&amp;info);
<a name="line39"> 39: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"matrix nonzeros = %D, allocated nonzeros = %D\n"</font>,
<a name="line40"> 40: </a>    (<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)info.nz_used,(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)info.nz_allocated);

<a name="line42"> 42: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(C);
<a name="line43"> 43: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line44"> 44: </a>  <font color="#4169E1">return</font> 0;
<a name="line45"> 45: </a>}
</pre>
</body>

</html>
